var distance[3];

var force[3];

var dist[3];

var friction;

var my_height;


var jump_speed = 5; // maniac's jumping animation speed

var jump_height = 50;
var jump_time = 1; // decreases while jumping to jump_time = -1

////////////////////
//bullet var
var bullet1_speed;
////////////////////

//var zap_handle;

sound shoot1_snd = <zap.wav>;

//sound zap = <zap.wav>;


string qkey_mdl = <qkey4.mdl>;

string bullet_mdl = <qkey3.mdl>;


/////////////////////////////////////////////////////////////////
//bullet functions see player for more bullet code
function init_shot();
function remove_bullet();
////////////////////////////////////////////////////////////////

function effect_explo();
function qref_pickup();
function animate_a();



entity* player;

action qref_move
{

	player=me;


	while (player!=null) {


		/////////////////////////////////////////////////////////////////////////////////
		//create player bullet here
		if (mouse_left == 1) // fire with the left mouse button
		{
			snd_play (shoot1_snd, 70, 0);
			ent_cycle ("walk", 100); // set the last "attack" frame
			wait (1); // make sure that the bullet will go in the right direction
			ent_create (bullet_mdl, my.skill21, init_shot);
			while (mouse_left == 1) {wait (1);}
		}
		/////////////////////////////////////////////////////////////////////////////////


		force.PAN = -10 * KEY_FORCE.X; // calculate rotation force
		my.SKILL14 = TIME*force.PAN + max(1-TIME*0.7,0)*my.SKILL14; // rotation speed
		my.PAN += TIME * my.SKILL14; // rotate the player
		
		vec_set(temp,my.x);
		temp.z -= 4000; // calculate a position 4000 quants below the player
		// set a trace mode for using the player's hull, and detecting map entities and level surfaces only 
		trace_mode = ignore_me+ignore_sprites+IGNORE_MODELS+USE_BOX;
		result = trace(my.x,temp); // subtract vertical distance to ground


		my_height = trace(my.x, temp);
		my_height = (result + 2*my_height) / 3;


		if (RESULT > 5) // in the air?
		{ 
			force.X = .2; // no pushing force
			force.Y = .15;
			force.Z = -5; // gravity force
			friction = 0.1; // air friction
			
		}
		else // on or near ground
		{ 
			force.X = 10 * KEY_FORCE.Y; // translation force
			force.Y = 0; // if I'm on the ground, why worry
			force.Z = -.5 * result-my_height; // ground elasticity
			friction = 0.7; // ground friction
		}

		my.SKILL11 = TIME*force.X + max(1-TIME*friction,0)*my.SKILL11; // calculate ahead speed
		my.SKILL13 = TIME*force.Z + max(1-TIME*friction,0)*my.SKILL13; // calculate vertical speed
		dist.X = TIME * my.SKILL11; // distance ahead
		dist.y = 0;
		dist.Z = TIME * my.SKILL13; // distance down

		move_mode = ignore_passable + glide;
		ent_MOVE(dist,nullvector); // move the player
		
		//animate actor
		MY.SKILL4 += 6.0 * TIME;
		if(MY.SKILL4 > 100)
		{
			MY.SKILL4 %= 100;
		}

		animate_a();
	

		wait(1);

}

}



function animate_a()
{
	
	set_cameras();

	ent_cycle("Stand",MY.SKILL3);
	
	if(Key_cuu == 1)||(Key_cud == 1)
	{

		
		ent_cycle("Walk",MY.SKILL4);
		my.skill4 += 4 * time; // "walk" animation speed
		
 
		if (my.skill4 > 100) {my.skill4 = 0;} // loop animation
		
	}
	
	if(KEY_shiftr == 1)//&&(KEY_cuu ==1)||(Key_cud == 1)
	{ 
		ent_cycle("Run",MY.SKILL5);
		my.skill5 += 22 * time; // "walk" animation speed

		if (my.skill5 > 100) {my.skill5 = 0;} // loop animation
	}

	if(KEY_ctrl == 1)  //Jump button
	{
		
		ent_cycle("Jump",MY.SKILL7);
		MY.SKILL7 += 7 * time; // "jump" animation speed 
		
		while (jump_time > -.001) 
		{ 
			if (key_ctrl == 0)  {return;} 
			my.skill13 = jump_height * time +.7*abs(my.skill11); 
			jump_time -= 0.04 * time; 
			wait (12); 
		} 
		while (key_ctrl == 1) {wait (1);} 
		jump_time = 1; 

	} //end if
	
}


//////////////////////////////////////////////////////////////////////
//pickup and attach gun

function qref_pickup()
{    

	you=player;


	if(event_type==event_impact)&&(YOU==PLAYER)
	{  
		proc_late();
		my.passable = on;
		my.metal = on;
		while(you == NULL){wait(1);}
		
		
		while(you)
		{ 

			vec_set(my.x,you.x);
			vec_set(my.pan,you.pan);
			my.frame = you.frame;
			my.next_frame = you.next_frame;
			vec_for_vertex (you.skill21, you, 309);  // soldier's bullet position is stored in soldier's skill21
			wait(1);
		}

		ent_remove(my);
	}
}


//////////////////////////////////////////////////////////////////////
//rotate gun 

action ent_rotate
{
	my.enable_impact=on;
	my.event = qref_pickup;
	while(1)
{
		my.pan += 1 * time;
		wait(1);
}
	remove(me);
}

/////////////////////////////////////////////////////////////////////
//random lights

function dia_light()
{
	while (1) { // rotate counterclockwise
		my.lightred = nRandom(77);
		my.lightgreen = nRandom(77);
		my.lightblue = nRandom(77);
		my.lightrange =  150;
		waitt( 214);
		my.lightrange =  250 ;
		waitt ( 277);
		my.z = (248);
}
}

///////////////////////////////////////////////////////////////////////
//initialize gun and move bullet

function init_shot()
{
	//zap_handle = ent_playloop(my,zap,100);
	dia_light();
	my.pan = you.pan;
	my.passable = on;
	//my.visible = off;
	//my.invisible = on;
	my.scale_x=.02;
	my.scale_y=.02;
	my.tilt = you.tilt;
	my.skill10 = 1; // this is a bullet fired by the soldier
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_bullet;
	my.ambient = 100;
	my.skill1 = 0;
	bullet1_speed.x = 100;
	bullet1_speed.y = 0;
	bullet1_speed.z = 0;
	bullet1_speed *= time;
	while ((my != null) && (my.skill1 < 500)) // 500 = max distance
	{
		my.skill1 += 1 * time;
		move_mode = ignore_you + ignore_passents;
		ent_move (bullet1_speed, nullvector);
		//emmit particlse
		MY.X = my.x + (3* SIN(MY.SKILL1-150*nRandom(33)));
		effect(effect_explo, 12 ,my.x,normal);
		wait (1);
	}
	ent_remove (me);
}



function remove_bullet()
{
	wait (1);
	ent_remove (me);
}

